// snowmobile_sounds.cs

datablock AudioProfile(Snowmobile_StartupSound)
{
   filename    = "./sm_start.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(SnowmobileIdleSound)
{
   filename    = "./sm_idle.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};
datablock AudioProfile(Snowmobile_ShutOffSound)
{
   filename    = "./sm_off.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(Snowmobile_lightCrashSound)
{
   filename    = "./sm_lightCrash.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(Snowmobile_heavyCrashSound)
{
   filename    = "./sm_heavyCrash.wav";
   description = AudioDefault3d;
   preload = true;
};

package Snowmobile_EngineSounds
{
   function armor::onMount(%this,%obj,%col,%a,%b)
   {
      Parent::onMount(%this,%obj,%col,%a,%b);
      if(%col.getDatablock().isSnowmobile)
      {
         schedule(0,0,snowmobile_StartupAudio,%col);
         cancel(%col.audioLoop);
         %col.audioLoop = schedule(3000,0,snowmobile_startLoopAudio,%col);
      }
   }
   function armor::onUnMount(%this,%obj,%col)
   {
      Parent::onUnMount(%this,%obj,%col);
      if(%col.dataBlock.isSnowmobile)
      {
         cancel(%col.audioLoop);
         schedule(0,0,snowmobile_StopLoopAudio,%col);
      }
   }
};

ActivatePackage(Snowmobile_EngineSounds);

function snowmobile_StartupAudio(%veh)
{
   %veh.playAudio(0, Snowmobile_StartupSound);
}
function snowmobile_StartLoopAudio(%veh)
{
   %veh.playAudio(0, SnowmobileIdleSound);
}
function snowmobile_StopLoopAudio(%veh)
{
   %veh.playAudio(0, Snowmobile_ShutOffSound);
}