// support stuff for the SnowMobile vehicle
exec("./SnowMobile_Tire.cs");
exec("./SnowMobile_Explosion.cs");
exec("./SnowMobile_FinalExplosion.cs");
exec("./SnowMobile_Spring.cs");
exec("./SnowMobile_Sounds.cs");

datablock ParticleData(SledParticle)
{
	textureName          = "base/data/particles/cloud";
	dragCoefficient      = 2.0;
	gravityCoefficient   = -0.1;
	inheritedVelFactor   = 0.1;
	constantAcceleration = 0.0;
	lifetimeMS           = 800;
	lifetimeVarianceMS   = 250;
	useInvAlpha = false;

	colors[0]     = "0.9 0.9 0.9 0.0";
	colors[1]     = "0.9 0.9 0.9 1.0";
	colors[2]     = "0.9 0.9 0.9 0.0";

	sizes[0]      = 0.50;
	sizes[1]      = 0.70;
	sizes[2]      = 0.25;

	times[0] = 0.0;
	times[1] = 0.2;
	times[2] = 1.0;
};

datablock ParticleEmitterData(SledEmitter)
{
   ejectionPeriodMS = 18;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 5;
   thetaMax         = 20;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = SledParticle;
};

datablock WheeledVehicleData(snowmobileVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./snowmobile.dts"; //"~/data/shapes/skivehicle.dts"; //
	emap = true;
	minMountDist = 3;

	numMountPoints = 1;
	mountThread[0] = "sit";

	maxDamage = 200.00;
	destroyedLevel = 200.00;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 -0.5 0.5"; //"0 0 0"

	maxSteeringAngle = 0.6;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = SledEmitter;

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 5.15;         // Far distance from vehicle
	cameraOffset = 5;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
	collisionTol = 0.1;        // Collision distance tolerance
	contactTol = 0.1;

	useEyePoint = false;	

	defaultTire	= snowmobileTire;
	defaultSpring	= snowmobileSpring;

	numWheels = 4;

	// Rigid Body
	mass = 300;
	density = 5.0;
	drag = 4.5;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 5;        // Impacts over this invoke the script callback
	softImpactSpeed = 5;       // Play SoftImpact Sound
	hardImpactSpeed = 10;      // Play HardImpact Sound
	groundImpactMinSpeed    = 5.0;

	// Engine
	engineTorque = 3500;       // Engine power
	engineBrake = 2500;         // Braking when throttle is 0
	brakeTorque = 5000;        // When brakes are applied
	maxWheelSpeed = 33;        // Engine scale by current speed / max speed

	rollForce		= 900;
	yawForce		= 600;
	pitchForce		= 1000;
	rotationalDrag		= 0.2;

	// Advanced Steering
	steeringAutoReturn = true;
	steeringAutoReturnRate = 1;	
	steeringAutoReturnMaxSpeed = 10;
	steeringUseStrafeSteering = true;
	steeringStrafeSteeringRate = 0.08;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	mediumSplashSound = Splash1Sound;
	hardSplashSound = Splash1Sound;
	exitSplashSound = exitWaterSound;
	softImpactSound = Snowmobile_lightCrashSound;
	hardImpactSound = Snowmobile_heavyCrashSound;

	justcollided = 0;

	uiName = "Snowmobile";
	rideable = true;
		lookUpLimit = 0.72;
		lookDownLimit = 0.72;

	paintable = true;
   
	damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

	damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

	numDmgEmitterAreas = 1;

	initialExplosionProjectile = snowmobileExplosionProjectile;
	initialExplosionOffset = 0;         //offset only uses a z value for now

	burnTime = 4000;

	finalExplosionProjectile = snowmobileFinalExplosionProjectile;
	finalExplosionOffset = 0.5;          //offset only uses a z value for now

	minRunOverSpeed    = 5;   //how fast you need to be going to run someone over (do damage)
	runOverDamageScale = 8;   //when you run over someone, speed * runoverdamagescale = damage amt
	runOverPushScale   = 1.2; //how hard a person you're running over gets pushed

	//protection for passengers
	protectPassengersBurn   = false;  //protect passengers from the burning effect of explosions?
	protectPassengersRadius = true;  //protect passengers from radius damage (explosions) ?
	protectPassengersDirect = false; //protect passengers from direct damage (bullets) ?
	isSnowmobile = 1; //Instead of checking for each individual snowmobile, lets just set a var.
};

package RaiseHands
{
   function armor::onMount(%this,%obj,%col,%a,%b)
   {
      Parent::onMount(%this,%obj,%col,%a,%b);
      if(%col.getDatablock().isSnowmobile)
      {
         %obj.playthread(2,armreadyboth);
      }
   }
   function armor::onUnMount(%this,%obj,%col)
   {
      Parent::onUnMount(%this,%obj,%col);
      if(%col.getDatablock().isSnowmobile)
      {
         %obj.playthread(2,root);
      }
   }
};
ActivatePackage(RaiseHands);

function snowmobileVehicle::onadd(%this, %obj)
{
	parent::onadd(%this,%obj);
	%obj.setWheelPowered(0,false);
	%obj.setWheelPowered(1,false);
	%obj.setWheelPowered(2,false);
	%obj.setWheelPowered(3,false);
}

package Snowmobile_EngineStartup
{
   function armor::onMount(%this,%obj,%col,%a,%b)
   {
      Parent::onMount(%this,%obj,%col,%a,%b);
      if(%col.getDatablock().isSnowmobile)
      {
         schedule(0,0,snowmobile_StopEngine,%col);
         schedule(3000,0,snowmobile_StartEngine,%col);
      }
   }
   function armor::onUnMount(%this,%obj,%col)
   {
      Parent::onUnMount(%this,%obj,%col);
      if(%col.getDatablock().isSnowmobile)
      {
         schedule(0,0,snowmobile_StopEngine,%col);
      }
   }
};

ActivatePackage(Snowmobile_EngineStartup);

function snowmobile_StartEngine(%veh)
{
   %veh.setWheelPowered(0,true);
   %veh.setWheelPowered(1,true);
   %veh.setWheelPowered(2,true);
   %veh.setWheelPowered(3,true);
}
function snowmobile_StopEngine(%veh)
{
   %veh.setWheelPowered(0,false);
   %veh.setWheelPowered(1,false);
   %veh.setWheelPowered(2,false);
   %veh.setWheelPowered(3,false);
}